#ifndef _MY_HEADER_H
#define _MY_HEADER_H

typedef enum {NO_DATA1,SERVO_MOVE, NEW_POSITION,WAIT=20,SLAVE_TRANSMISION=41, AWAITING_ORDER=42} order;

/* SUB ORDERS :
  - 0 : initial position
  - 1 to 5 : Servos
  - 42 : Odometry position for transmission to the Master
  - 50 : Debug mode, transmission of all data to the Master */
typedef enum {NO_DATA2,SERVO_LEFT, SERVO_RIGHT,SERVO_TOP,SERVO_BOTTOM,POSITION_X2,POSITION_X3,ODOMETRY_POSITION=42,SERVO_CAMERA,DEBUG=50} sub_order;

typedef struct DATA_STRUCTURE{
  //put your variable definitions here for the data you want to receive
  //THIS MUST BE EXACTLY THE SAME ON THE OTHER ARDUINO
  float data1;
  float data2;
  float data3;
  float data4;
 // float data3;
  //float data4;
  order current1;
  sub_order current2;
};
typedef struct {
	// position of the robot	
	int currentX;
	int currentY;
	float currentPhi;

	// commands
	int commandX;
	int commandY;
	float commandDistance;
	float commandPhi;
	
	// starting position
	int x0;
	int y0;
	float phi0;
	
	// Commands
	float rightMotorCommand;
	float leftMotorCommand;
} AUTO_INFO;

typedef struct {
	long ticksR;
	long ticksL;

        long disCovR;
        long disCovL;	
} ENCODER_INFO;

typedef struct {
	float Kp;
	float Ki;
	float Kd;
	float T;

	float previousError; 
	float previousIntegral;
	
	float out;
} PID;

long dist_to_ticks(float dist);
#endif
